##// END OF EJS Templates
Merge pull request #186 from michalciolek/fix-gov...
drtyhlpr -
r591:f596eeac215d Fusion
parent child
Show More
@@ -1,869 +1,869
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63 # Kernel deb packages for 32bit kernel
64 64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 68 # Default precompiled 64bit kernel
69 69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 70 # Generic
71 71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 72 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
73 73 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
74 74
75 75 # Build directories
76 76 WORKDIR=$(pwd)
77 77 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
78 78 BUILDDIR="${BASEDIR}/build"
79 79
80 80 # Chroot directories
81 81 R="${BUILDDIR}/chroot"
82 82 ETC_DIR="${R}/etc"
83 83 LIB_DIR="${R}/lib"
84 84 BOOT_DIR="${R}/boot/firmware"
85 85 KERNEL_DIR="${R}/usr/src/linux"
86 86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
87 87 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
88 88
89 89 # Firmware directory: Blank if download from github
90 90 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
91 91
92 92 # General settings
93 93 SET_ARCH=${SET_ARCH:=32}
94 94 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
95 95 PASSWORD=${PASSWORD:=raspberry}
96 96 USER_PASSWORD=${USER_PASSWORD:=raspberry}
97 97 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
98 98 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
99 99 EXPANDROOT=${EXPANDROOT:=true}
100 100 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
101 101
102 102 # Keyboard settings
103 103 XKB_MODEL=${XKB_MODEL:=""}
104 104 XKB_LAYOUT=${XKB_LAYOUT:=""}
105 105 XKB_VARIANT=${XKB_VARIANT:=""}
106 106 XKB_OPTIONS=${XKB_OPTIONS:=""}
107 107
108 108 # Network settings (DHCP)
109 109 ENABLE_DHCP=${ENABLE_DHCP:=true}
110 110
111 111 # Network settings (static)
112 112 NET_ADDRESS=${NET_ADDRESS:=""}
113 113 NET_GATEWAY=${NET_GATEWAY:=""}
114 114 NET_DNS_1=${NET_DNS_1:=""}
115 115 NET_DNS_2=${NET_DNS_2:=""}
116 116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
117 117 NET_NTP_1=${NET_NTP_1:=""}
118 118 NET_NTP_2=${NET_NTP_2:=""}
119 119
120 120 # APT settings
121 121 APT_PROXY=${APT_PROXY:=""}
122 122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
123 123 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
124 124
125 125 # Feature settings
126 126 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
127 127 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
128 128 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
129 129 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
130 130 ENABLE_I2C=${ENABLE_I2C:=false}
131 131 ENABLE_SPI=${ENABLE_SPI:=false}
132 132 ENABLE_IPV6=${ENABLE_IPV6:=true}
133 133 ENABLE_SSHD=${ENABLE_SSHD:=true}
134 134 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
135 135 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
136 136 ENABLE_SOUND=${ENABLE_SOUND:=true}
137 137 ENABLE_DBUS=${ENABLE_DBUS:=true}
138 138 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
139 139 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
140 140 ENABLE_XORG=${ENABLE_XORG:=false}
141 141 ENABLE_WM=${ENABLE_WM:=""}
142 142 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
143 143 ENABLE_USER=${ENABLE_USER:=true}
144 144 USER_NAME=${USER_NAME:="pi"}
145 145 ENABLE_ROOT=${ENABLE_ROOT:=false}
146 146 ENABLE_QEMU=${ENABLE_QEMU:=false}
147 147 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
148 148
149 149 # SSH settings
150 150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
151 151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
152 152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
153 153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
154 154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
155 155
156 156 # Advanced settings
157 157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
163 163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
165 165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
166 166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
167 167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
168 168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
169 169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
170 170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
171 171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
172 172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
173 173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
174 174 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
175 175 ENABLE_LOGO=${ENABLE_LOGO:=true}
176 176 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
177 177 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
178 178
179 179 # Kernel compilation settings
180 180 BUILD_KERNEL=${BUILD_KERNEL:=true}
181 181 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
182 182 KERNEL_THREADS=${KERNEL_THREADS:=1}
183 183 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
184 184 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
185 185 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
186 186 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
187 187 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
188 188 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
189 189 KERNEL_VIRT=${KERNEL_VIRT:=false}
190 190 KERNEL_BPF=${KERNEL_BPF:=false}
191 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=powersave}
191 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
192 192 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
193 193 KERNEL_NF=${KERNEL_NF:=false}
194 194
195 195 # Kernel compilation from source directory settings
196 196 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
197 197 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
198 198 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
199 199 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
200 200
201 201 # Reduce disk usage settings
202 202 REDUCE_APT=${REDUCE_APT:=true}
203 203 REDUCE_DOC=${REDUCE_DOC:=true}
204 204 REDUCE_MAN=${REDUCE_MAN:=true}
205 205 REDUCE_VIM=${REDUCE_VIM:=false}
206 206 REDUCE_BASH=${REDUCE_BASH:=false}
207 207 REDUCE_HWDB=${REDUCE_HWDB:=true}
208 208 REDUCE_SSHD=${REDUCE_SSHD:=true}
209 209 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
210 210
211 211 # Encrypted filesystem settings
212 212 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
213 213 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
214 214 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
215 215 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
216 216 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
217 217 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
218 218 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
219 219 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
220 220 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
221 221
222 222 # Chroot scripts directory
223 223 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
224 224
225 225 # Packages required in the chroot build environment
226 226 APT_INCLUDES=${APT_INCLUDES:=""}
227 227 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
228 228
229 229 # Packages to exclude from chroot build environment
230 230 APT_EXCLUDES=${APT_EXCLUDES:=""}
231 231
232 232 # Packages required for bootstrapping
233 233 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
234 234 MISSING_PACKAGES=""
235 235
236 236 # Packages installed for c/c++ build environment in chroot (keep empty)
237 237 COMPILER_PACKAGES=""
238 238
239 239 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
240 240 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
241 241 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
242 242 APT_PROXY=http://127.0.0.1:3142/
243 243 fi
244 244
245 245 # Setup architecture specific settings
246 246 if [ -n "$SET_ARCH" ] ; then
247 247 # 64-bit configuration
248 248 if [ "$SET_ARCH" = 64 ] ; then
249 249 # General 64-bit depended settings
250 250 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
251 251 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
252 252 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
253 253
254 254 # Raspberry Pi model specific settings
255 255 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
256 256 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
257 257 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
258 258 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
259 259 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
260 260 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
261 261 else
262 262 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
263 263 exit 1
264 264 fi
265 265 fi
266 266
267 267 # 32-bit configuration
268 268 if [ "$SET_ARCH" = 32 ] ; then
269 269 # General 32-bit dependend settings
270 270 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
271 271 KERNEL_ARCH=${KERNEL_ARCH:=arm}
272 272 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
273 273
274 274 # Raspberry Pi model specific settings
275 275 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
276 276 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
277 277 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
278 278 RELEASE_ARCH=${RELEASE_ARCH:=armel}
279 279 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
280 280 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
281 281 fi
282 282
283 283 # Raspberry Pi model specific settings
284 284 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
285 285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
286 286 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
287 287 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
288 288 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
289 289 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
290 290 fi
291 291 fi
292 292 # SET_ARCH not set
293 293 else
294 294 echo "error: Please set '32' or '64' as value for SET_ARCH"
295 295 exit 1
296 296 fi
297 297 # Device specific configuration and U-Boot configuration
298 298 case "$RPI_MODEL" in
299 299 0)
300 300 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
301 301 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
302 302 ;;
303 303 1)
304 304 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
305 305 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
306 306 ;;
307 307 1P)
308 308 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
309 309 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
310 310 ;;
311 311 2)
312 312 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
313 313 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
314 314 ;;
315 315 3)
316 316 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
317 317 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
318 318 ;;
319 319 3P)
320 320 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
321 321 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
322 322 ;;
323 323 *)
324 324 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
325 325 exit 1
326 326 ;;
327 327 esac
328 328
329 329 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
330 330 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
331 331 # Include bluetooth packages on supported boards
332 332 if [ "$ENABLE_BLUETOOTH" = true ] ; then
333 333 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
334 334 fi
335 335 if [ "$ENABLE_WIRELESS" = true ] ; then
336 336 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
337 337 fi
338 338 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
339 339 # Check if the internal wireless interface is not supported by the RPi model
340 340 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
341 341 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
342 342 exit 1
343 343 fi
344 344 fi
345 345
346 346 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
347 347 echo "error: You have to compile kernel sources, if you want to enable nexmon"
348 348 exit 1
349 349 fi
350 350
351 351 # Prepare date string for default image file name
352 352 DATE="$(date +%Y-%m-%d)"
353 353 if [ -z "$KERNEL_BRANCH" ] ; then
354 354 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
355 355 else
356 356 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
357 357 fi
358 358
359 359 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
360 360 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
361 361 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
362 362 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
363 363 exit 1
364 364 fi
365 365 fi
366 366
367 367 # Add cmake to compile videocore sources
368 368 if [ "$ENABLE_VIDEOCORE" = true ] ; then
369 369 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
370 370 fi
371 371
372 372 # Add deps for nexmon
373 373 if [ "$ENABLE_NEXMON" = true ] ; then
374 374 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
375 375 fi
376 376
377 377 # Add libncurses5 to enable kernel menuconfig
378 378 if [ "$KERNEL_MENUCONFIG" = true ] ; then
379 379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
380 380 fi
381 381
382 382 # Add ccache compiler cache for (faster) kernel cross (re)compilation
383 383 if [ "$KERNEL_CCACHE" = true ] ; then
384 384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
385 385 fi
386 386
387 387 # Add cryptsetup package to enable filesystem encryption
388 388 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
389 389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
390 390 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
391 391
392 392 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
393 393 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
394 394 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
395 395 fi
396 396
397 397 if [ -z "$CRYPTFS_PASSWORD" ] ; then
398 398 echo "error: no password defined (CRYPTFS_PASSWORD)!"
399 399 exit 1
400 400 fi
401 401 ENABLE_INITRAMFS=true
402 402 fi
403 403
404 404 # Add initramfs generation tools
405 405 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
406 406 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
407 407 fi
408 408
409 409 # Add device-tree-compiler required for building the U-Boot bootloader
410 410 if [ "$ENABLE_UBOOT" = true ] ; then
411 411 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
412 412 fi
413 413
414 414 if [ "$ENABLE_USBBOOT" = true ] ; then
415 415 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
416 416 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
417 417 exit 1
418 418 fi
419 419 fi
420 420
421 421 # Check if root SSH (v2) public key file exists
422 422 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
423 423 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
424 424 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
425 425 exit 1
426 426 fi
427 427 fi
428 428
429 429 # Check if $USER_NAME SSH (v2) public key file exists
430 430 if [ -n "$SSH_USER_PUB_KEY" ] ; then
431 431 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
432 432 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
433 433 exit 1
434 434 fi
435 435 fi
436 436
437 437 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
438 438 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
439 439 exit 1
440 440 fi
441 441
442 442 # Check if all required packages are installed on the build system
443 443 for package in $REQUIRED_PACKAGES ; do
444 444 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
445 445 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
446 446 fi
447 447 done
448 448
449 449 # If there are missing packages ask confirmation for install, or exit
450 450 if [ -n "$MISSING_PACKAGES" ] ; then
451 451 echo "the following packages needed by this script are not installed:"
452 452 echo "$MISSING_PACKAGES"
453 453
454 454 printf "\ndo you want to install the missing packages right now? [y/n] "
455 455 read -r confirm
456 456 [ "$confirm" != "y" ] && exit 1
457 457
458 458 # Make sure all missing required packages are installed
459 459 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
460 460 fi
461 461
462 462 # Check if ./bootstrap.d directory exists
463 463 if [ ! -d "./bootstrap.d/" ] ; then
464 464 echo "error: './bootstrap.d' required directory not found!"
465 465 exit 1
466 466 fi
467 467
468 468 # Check if ./files directory exists
469 469 if [ ! -d "./files/" ] ; then
470 470 echo "error: './files' required directory not found!"
471 471 exit 1
472 472 fi
473 473
474 474 # Check if specified KERNELSRC_DIR directory exists
475 475 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
476 476 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
477 477 exit 1
478 478 fi
479 479
480 480 # Check if specified UBOOTSRC_DIR directory exists
481 481 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
482 482 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
483 483 exit 1
484 484 fi
485 485
486 486 # Check if specified VIDEOCORESRC_DIR directory exists
487 487 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
488 488 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
489 489 exit 1
490 490 fi
491 491
492 492 # Check if specified FBTURBOSRC_DIR directory exists
493 493 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
494 494 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
495 495 exit 1
496 496 fi
497 497
498 498 # Check if specified NEXMONSRC_DIR directory exists
499 499 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
500 500 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
501 501 exit 1
502 502 fi
503 503
504 504 # Check if specified CHROOT_SCRIPTS directory exists
505 505 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
506 506 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
507 507 exit 1
508 508 fi
509 509
510 510 # Check if specified device mapping already exists (will be used by cryptsetup)
511 511 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
512 512 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
513 513 exit 1
514 514 fi
515 515
516 516 # Don't clobber an old build
517 517 if [ -e "$BUILDDIR" ] ; then
518 518 echo "error: directory ${BUILDDIR} already exists, not proceeding"
519 519 exit 1
520 520 fi
521 521
522 522 # Setup chroot directory
523 523 mkdir -p "${R}"
524 524
525 525 # Check if build directory has enough of free disk space >512MB
526 526 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
527 527 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
528 528 exit 1
529 529 fi
530 530
531 531 set -x
532 532
533 533 # Call "cleanup" function on various signals and errors
534 534 trap cleanup 0 1 2 3 6
535 535
536 536 # Add required packages for the minbase installation
537 537 if [ "$ENABLE_MINBASE" = true ] ; then
538 538 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
539 539 fi
540 540
541 541 # Add parted package, required to get partprobe utility
542 542 if [ "$EXPANDROOT" = true ] ; then
543 543 APT_INCLUDES="${APT_INCLUDES},parted"
544 544 fi
545 545
546 546 # Add dphys-swapfile package, required to enable swap
547 547 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
548 548 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
549 549 fi
550 550
551 551 # Add dbus package, recommended if using systemd
552 552 if [ "$ENABLE_DBUS" = true ] ; then
553 553 APT_INCLUDES="${APT_INCLUDES},dbus"
554 554 fi
555 555
556 556 # Add iptables IPv4/IPv6 package
557 557 if [ "$ENABLE_IPTABLES" = true ] ; then
558 558 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
559 559 fi
560 560 # Add apparmor for KERNEL_SECURITY
561 561 if [ "$KERNEL_SECURITY" = true ] ; then
562 562 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
563 563 fi
564 564
565 565 # Add openssh server package
566 566 if [ "$ENABLE_SSHD" = true ] ; then
567 567 APT_INCLUDES="${APT_INCLUDES},openssh-server"
568 568 fi
569 569
570 570 # Add alsa-utils package
571 571 if [ "$ENABLE_SOUND" = true ] ; then
572 572 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
573 573 fi
574 574
575 575 # Add rng-tools package
576 576 if [ "$ENABLE_HWRANDOM" = true ] ; then
577 577 APT_INCLUDES="${APT_INCLUDES},rng-tools"
578 578 fi
579 579
580 580 # Add fbturbo video driver
581 581 if [ "$ENABLE_FBTURBO" = true ] ; then
582 582 # Enable xorg package dependencies
583 583 ENABLE_XORG=true
584 584 fi
585 585
586 586 # Add user defined window manager package
587 587 if [ -n "$ENABLE_WM" ] ; then
588 588 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
589 589
590 590 # Enable xorg package dependencies
591 591 ENABLE_XORG=true
592 592 fi
593 593
594 594 # Add xorg package
595 595 if [ "$ENABLE_XORG" = true ] ; then
596 596 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
597 597 fi
598 598
599 599 # Replace selected packages with smaller clones
600 600 if [ "$ENABLE_REDUCE" = true ] ; then
601 601 # Add levee package instead of vim-tiny
602 602 if [ "$REDUCE_VIM" = true ] ; then
603 603 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
604 604 fi
605 605
606 606 # Add dropbear package instead of openssh-server
607 607 if [ "$REDUCE_SSHD" = true ] ; then
608 608 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
609 609 fi
610 610 fi
611 611
612 612 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
613 613 if [ "$ENABLE_SYSVINIT" = false ] ; then
614 614 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
615 615 fi
616 616
617 617 # Configure kernel sources if no KERNELSRC_DIR
618 618 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
619 619 KERNELSRC_CONFIG=true
620 620 fi
621 621
622 622 # Configure reduced kernel
623 623 if [ "$KERNEL_REDUCE" = true ] ; then
624 624 KERNELSRC_CONFIG=false
625 625 fi
626 626
627 627 # Configure qemu compatible kernel
628 628 if [ "$ENABLE_QEMU" = true ] ; then
629 629 DTB_FILE=vexpress-v2p-ca15_a7.dtb
630 630 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
631 631 KERNEL_DEFCONFIG="vexpress_defconfig"
632 632 if [ "$KERNEL_MENUCONFIG" = false ] ; then
633 633 KERNEL_OLDDEFCONFIG=true
634 634 fi
635 635 fi
636 636
637 637 # Execute bootstrap scripts
638 638 for SCRIPT in bootstrap.d/*.sh; do
639 639 head -n 3 "$SCRIPT"
640 640 . "$SCRIPT"
641 641 done
642 642
643 643 ## Execute custom bootstrap scripts
644 644 if [ -d "custom.d" ] ; then
645 645 for SCRIPT in custom.d/*.sh; do
646 646 . "$SCRIPT"
647 647 done
648 648 fi
649 649
650 650 # Execute custom scripts inside the chroot
651 651 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
652 652 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
653 653 chroot_exec /bin/bash -x <<'EOF'
654 654 for SCRIPT in /chroot_scripts/* ; do
655 655 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
656 656 $SCRIPT
657 657 fi
658 658 done
659 659 EOF
660 660 rm -rf "${R}/chroot_scripts"
661 661 fi
662 662
663 663 # Remove c/c++ build environment from the chroot
664 664 chroot_remove_cc
665 665
666 666 # Generate required machine-id
667 667 MACHINE_ID=$(dbus-uuidgen)
668 668 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
669 669 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
670 670
671 671 # APT Cleanup
672 672 chroot_exec apt-get -y clean
673 673 chroot_exec apt-get -y autoclean
674 674 chroot_exec apt-get -y autoremove
675 675
676 676 # Unmount mounted filesystems
677 677 umount -l "${R}/proc"
678 678 umount -l "${R}/sys"
679 679
680 680 # Clean up directories
681 681 rm -rf "${R}/run/*"
682 682 rm -rf "${R}/tmp/*"
683 683
684 684 # Clean up APT proxy settings
685 685 if [ "$KEEP_APT_PROXY" = false ] ; then
686 686 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
687 687 fi
688 688
689 689 # Clean up files
690 690 rm -f "${ETC_DIR}/ssh/ssh_host_*"
691 691 rm -f "${ETC_DIR}/dropbear/dropbear_*"
692 692 rm -f "${ETC_DIR}/apt/sources.list.save"
693 693 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
694 694 rm -f "${ETC_DIR}/*-"
695 695 rm -f "${ETC_DIR}/resolv.conf"
696 696 rm -f "${R}/root/.bash_history"
697 697 rm -f "${R}/var/lib/urandom/random-seed"
698 698 rm -f "${R}/initrd.img"
699 699 rm -f "${R}/vmlinuz"
700 700 rm -f "${R}${QEMU_BINARY}"
701 701
702 702 if [ "$ENABLE_QEMU" = true ] ; then
703 703 # Setup QEMU directory
704 704 mkdir "${BASEDIR}/qemu"
705 705
706 706 # Copy kernel image to QEMU directory
707 707 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
708 708
709 709 # Copy kernel config to QEMU directory
710 710 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
711 711
712 712 # Copy kernel dtbs to QEMU directory
713 713 for dtb in "${BOOT_DIR}/"*.dtb ; do
714 714 if [ -f "${dtb}" ] ; then
715 715 install_readonly "${dtb}" "${BASEDIR}/qemu/"
716 716 fi
717 717 done
718 718
719 719 # Copy kernel overlays to QEMU directory
720 720 if [ -d "${BOOT_DIR}/overlays" ] ; then
721 721 # Setup overlays dtbs directory
722 722 mkdir "${BASEDIR}/qemu/overlays"
723 723
724 724 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
725 725 if [ -f "${dtb}" ] ; then
726 726 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
727 727 fi
728 728 done
729 729 fi
730 730
731 731 # Copy u-boot files to QEMU directory
732 732 if [ "$ENABLE_UBOOT" = true ] ; then
733 733 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
734 734 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
735 735 fi
736 736 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
737 737 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
738 738 fi
739 739 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
740 740 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
741 741 fi
742 742 fi
743 743
744 744 # Copy initramfs to QEMU directory
745 745 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
746 746 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
747 747 fi
748 748 fi
749 749
750 750 # Calculate size of the chroot directory in KB
751 751 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
752 752
753 753 # Calculate the amount of needed 512 Byte sectors
754 754 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
755 755 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
756 756 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
757 757
758 758 # The root partition is EXT4
759 759 # This means more space than the actual used space of the chroot is used.
760 760 # As overhead for journaling and reserved blocks 35% are added.
761 761 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
762 762
763 763 # Calculate required image size in 512 Byte sectors
764 764 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
765 765
766 766 # Prepare image file
767 767 if [ "$ENABLE_SPLITFS" = true ] ; then
768 768 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
769 769 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
770 770 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
771 771 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
772 772
773 773 # Write firmware/boot partition tables
774 774 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
775 775 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
776 776 EOM
777 777
778 778 # Write root partition table
779 779 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
780 780 ${TABLE_SECTORS},${ROOT_SECTORS},83
781 781 EOM
782 782
783 783 # Setup temporary loop devices
784 784 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
785 785 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
786 786 else # ENABLE_SPLITFS=false
787 787 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
788 788 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
789 789
790 790 # Write partition table
791 791 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
792 792 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
793 793 ${ROOT_OFFSET},${ROOT_SECTORS},83
794 794 EOM
795 795
796 796 # Setup temporary loop devices
797 797 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
798 798 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
799 799 fi
800 800
801 801 if [ "$ENABLE_CRYPTFS" = true ] ; then
802 802 # Create dummy ext4 fs
803 803 mkfs.ext4 "$ROOT_LOOP"
804 804
805 805 # Setup password keyfile
806 806 touch .password
807 807 chmod 600 .password
808 808 echo -n ${CRYPTFS_PASSWORD} > .password
809 809
810 810 # Initialize encrypted partition
811 811 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
812 812
813 813 # Open encrypted partition and setup mapping
814 814 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
815 815
816 816 # Secure delete password keyfile
817 817 shred -zu .password
818 818
819 819 # Update temporary loop device
820 820 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
821 821
822 822 # Wipe encrypted partition (encryption cipher is used for randomness)
823 823 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
824 824 fi
825 825
826 826 # Build filesystems
827 827 mkfs.vfat "$FRMW_LOOP"
828 828 mkfs.ext4 "$ROOT_LOOP"
829 829
830 830 # Mount the temporary loop devices
831 831 mkdir -p "$BUILDDIR/mount"
832 832 mount "$ROOT_LOOP" "$BUILDDIR/mount"
833 833
834 834 mkdir -p "$BUILDDIR/mount/boot/firmware"
835 835 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
836 836
837 837 # Copy all files from the chroot to the loop device mount point directory
838 838 rsync -a "${R}/" "$BUILDDIR/mount/"
839 839
840 840 # Unmount all temporary loop devices and mount points
841 841 cleanup
842 842
843 843 # Create block map file(s) of image(s)
844 844 if [ "$ENABLE_SPLITFS" = true ] ; then
845 845 # Create block map files for "bmaptool"
846 846 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
847 847 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
848 848
849 849 # Image was successfully created
850 850 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
851 851 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
852 852 else
853 853 # Create block map file for "bmaptool"
854 854 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
855 855
856 856 # Image was successfully created
857 857 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
858 858
859 859 # Create qemu qcow2 image
860 860 if [ "$ENABLE_QEMU" = true ] ; then
861 861 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
862 862 QEMU_SIZE=16G
863 863
864 864 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
865 865 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
866 866
867 867 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
868 868 fi
869 869 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant